<?php
/*
Plugin Name: Silent warning
Plugin URI:  http://wpdemo.dovi42.hu/silent-warning/
Description: The plugin will notify the administrator if intervention is required.
Version:     1.20
Author:      Dovi42
Author URI:  http://dovi42.hu
License:     GPLv2 or later
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: silent-warning
Generator:   WP Creator - http://wpcreator.hu - 2019-12-24 11:10:06 
*/

if ( !defined( 'ABSPATH' ) ) exit;

function silent_warning_802_get_options($id) { 
    if ($id != "") : 

        // Set default option values
        $defaults = array(
             'index_size'     => 0,
             'config_size'    => 0,
             'access_size'    => 0,
             'storage_limit'  => 10,
             'database_limit' => 15,
             'admin_count'    => 0,
             'health'         => 0,
			 'to_admins'       => '1',
			 'to_other'        => ''
            );

        // Get the set plugin option values
        $options = get_option($id);

        foreach ($defaults as $key => $value) {
            // If not set then set the default 
            if (!isset($options[$key])) {
                $options[$key] = $defaults[$key];
            }
        }
        return $options;
    else:
        return array();
    endif;
}


function silent_warning_802_load_textdomain() {
    load_plugin_textdomain( 'silent-warning', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
}
add_action( 'plugins_loaded', 'silent_warning_802_load_textdomain' );

// Show notice 
// Üzenet megjelenítése
function silent_warning_802_notices() {
    if( get_transient( 'silent_warning_802_activation_notice' ) ) {
        echo '<div class="notice notice-success"><p>' . __('Number of administrators, size of <em>/index.php</em>, <em>/wp-config.php</em> and <em>/.htaccess</em> saved.', 'silent-warning') . '</p></div>';
        delete_transient( 'silent_warning_802_activation_notice' );
    }
}
add_action( 'admin_notices', 'silent_warning_802_notices' );

function silent_warning_802_activation() {
    // A plugin aktiválásakor fut le
    // Call when plugin is activated

    $options = silent_warning_802_get_options('silent_warning_options');
    $options['index_size']  = filesize( ABSPATH . 'index.php' );
    $options['config_size'] = filesize( ABSPATH . 'wp-config.php' );
    if (file_exists(ABSPATH . '.htaccess')) {
        $options['access_size'] = filesize( ABSPATH . '.htaccess' );
    } else {
        $options['access_size'] = 0;
    }

    $user_count_data = count_users();
    $options['admin_count'] = $user_count_data['avail_roles']['administrator'];
    
	$get_issues = get_transient( 'health-check-site-status-result' );
	$issue_counts = array();
	if ( false !== $get_issues ) { $issue_counts = json_decode( $get_issues, true ); }
	if ( ! is_array( $issue_counts ) || ! $issue_counts ) {
		$issue_counts = array(
			'good'        => 0,
			'recommended' => 0,
			'critical'    => 0,
		);
	}
    $issues_total = $issue_counts['recommended'] + $issue_counts['critical'];
    $options['health'] = $issues_total;
    
    update_option('silent_warning_options', $options, true);
    update_option('silent_warning_show_alert', true, true);
    update_option('silent_warning_legend', array(0,0,0,0, array(0,0,0,0),0,0,0), true);
    
    add_action( 'admin_notices', 'silent_warning_802_notice' );
    set_transient( 'silent_warning_802_activation_notice', 1);

	if( !wp_next_scheduled( 'silent_warning_cron_job' ) ) {  
	   wp_schedule_event( time(), 'hourly', 'silent_warning_cron_job' );  
	}
}
register_activation_hook( __FILE__, 'silent_warning_802_activation' );

function silent_warning_802_deactivation() {
    // A plugin deaktiválásakor fut le
    // Call when plugin is deactivated
    delete_option('silent_warning_options');
    delete_option('silent_warning_legend');
    
    wp_clear_scheduled_hook('silent_warning_cron_job');
}
register_deactivation_hook( __FILE__, 'silent_warning_802_deactivation' );

function silent_warning_802_uninstall() {
    // A plugin törlésekor fut le
    // Call when plugin is uninstall

}
register_uninstall_hook( __FILE__, 'silent_warning_802_uninstall' );
function silent_warning_802_upgrade_completed( $upgrader_object, $options ) {
    $our_plugin = plugin_basename( __FILE__ );
    if( $options['action'] == 'update' && $options['type'] == 'plugin' && isset( $options['plugins'] ) ) {
        foreach( $options['plugins'] as $plugin ) {
            if( $plugin == $our_plugin ) {

                $error = false;
                                
                $options = silent_warning_802_get_options('silent_warning_options');
                $options['index_size']  = filesize( ABSPATH . 'index.php' );
                $options['config_size'] = filesize( ABSPATH . 'wp-config.php' );
                if (file_exists(ABSPATH . '.htaccess')) {
                    $options['access_size'] = filesize( ABSPATH . '.htaccess' );
                } else {
                    $options['access_size'] = 0;
                }
            
                $user_count_data = count_users();
                $options['admin_count'] = $user_count_data['avail_roles']['administrator'];

            	$get_issues = get_transient( 'health-check-site-status-result' );
            	$issue_counts = array();
            	if ( false !== $get_issues ) {
            		$issue_counts = json_decode( $get_issues, true );
            	}
            
            	if ( ! is_array( $issue_counts ) || ! $issue_counts ) {
            		$issue_counts = array(
            			'good'        => 0,
            			'recommended' => 0,
            			'critical'    => 0,
            		);
            	}
                $issues_total = $issue_counts['recommended'] + $issue_counts['critical'];
                $options['health'] = $issues_total;
                
                update_option('silent_warning_options', $options, true);
                update_option('silent_warning_legend', array(0,0,0,0, array(0,0,0,0),0,0,0), true);
                update_option('silent_warning_show_alert', true, true);

            }
        }
    }
}
add_action( 'upgrader_process_complete', 'silent_warning_802_upgrade_completed', 10, 2 );


function silent_warning_802_deletefiles()
{
    $files = array('olvasdel.html','readme.html','licenc.txt','license.txt');
    foreach ($files as $file) {
        if (file_exists(ABSPATH . $file)) {
            unlink(ABSPATH . $file);
        }
    }    
}

function silent_warning_802_check_index($options)
{
    $size = filesize( ABSPATH . 'index.php' );
    if ($size == $options['index_size']) {
        return '';
    }
    return __('The size of the /index.php file has changed!', 'silent-warning') . '&nbsp;<small>[<span style="color:red">'.$size.'</span> != '.$options['index_size'].']</small>';
}

function silent_warning_802_check_config($options)
{
    $size = filesize( ABSPATH . 'wp-config.php' );
    if ($size == $options['config_size']) {
        return '';
    }
    return __('The size of the /wp-config.php file has changed!', 'silent-warning') . '&nbsp;<small>[<span style="color:red">'.$size.'</span> != '.$options['config_size'].']</small>';
}

function silent_warning_802_check_access($options)
{
    if (file_exists(ABSPATH . '.htaccess')) {
        $size = filesize( ABSPATH . '.htaccess' );
    } else {
        return '';
    }
    if ($size == $options['access_size']) {
        return '';
    }
    return __('The size of the /.htaccess file has changed!', 'silent-warning') . '&nbsp;<small>[<span style="color:red">'.$size.'</span> != '.$options['access_size'].']</small>';
}


function silent_warning_802_check_free($options)
{
    $disk_free = disk_free_space(dirname(__FILE__));
    
    if ($disk_free >= ($options['storage_limit'] * 1024 * 1024 * 1024)) {
        return '';
    }

    $si_prefix = array( 'B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB' );
    $base = 1024;
    $class = min((int)log($disk_free , $base) , count($si_prefix) - 1);
    $free = sprintf('%1.0f' , $disk_free / pow($base,$class)) . ' ' . $si_prefix[$class];

    return wp_sprintf( __('Free storage has dropped below the %s GB threshold!', 'silent-warning'), $options['storage_limit']) . '&nbsp;<small>['.$free.' ' . __('is free','silent-warning') . ']</small>';
}

function silent_warning_802_check_updates()
{
    $counts = array(
        'plugins'      => 0,
        'themes'       => 0,
        'wordpress'    => 0,
        'translations' => 0,
    );

    $lists = array(
        'plugins'      => array(),
        'themes'       => array(),
        'wordpress'    => array(),
        'translations' => array(),
    );

    $update_plugins = get_site_transient( 'update_plugins' );
    if ( ! empty( $update_plugins->response ) ) {
        $counts['plugins'] = count( $update_plugins->response );
        $items = array();
        foreach ($update_plugins->response as $key => $value) {
            $items[] = $value->slug . ' ' . $value->new_version;
        }
        $lists['plugins'] = implode(', ', $items);
    }

    $update_themes = get_site_transient( 'update_themes' );
    if ( ! empty( $update_themes->response ) ) {
        $counts['themes'] = count( $update_themes->response );
        $items = array();
        foreach ($update_themes->response as $key => $value) {
            $items[] = $key . ' ' . $update_themes->response[$key]['new_version'];
        }
        $lists['themes'] = implode(', ', $items);
    }

    $options = array(
            'available' => true,
            'dismissed' => false
        );
    $dismissed = get_site_option( 'dismissed_update_core' );
    if ( ! is_array( $dismissed ) ) { $dismissed = array(); }
    $from_api = get_site_transient( 'update_core' );
    $updates = $from_api->updates;
    $update_wordpress  = array();
    foreach ( $updates as $update ) {
        if ( $update->response == 'autoupdate' ) {
            continue;
        }
 
        if ( array_key_exists( $update->current . '|' . $update->locale, $dismissed ) ) {
            if ( $options['dismissed'] ) {
                $update->dismissed = true;
                $update_wordpress[] = $update;
            }
        } else {
            if ( $options['available'] ) {
                $update->dismissed = false;
                $update_wordpress[] = $update;
            }
        }
    }
    if ( ! empty( $update_wordpress ) && ! in_array( $update_wordpress[0]->response, array( 'development', 'latest' ) ) ) {
        $counts['wordpress'] = 1;
        $lists['wordpress'] = 'wordPress ' . $update_wordpress[0]->current . '-' . $update_wordpress[0]->locale;
    }    

    $update_translations = wp_get_translation_updates();
    if ( count($update_translations) > 0 ) {
        $counts['translations'] = 1;
        $items = array();
        foreach ($update_translations as $item) {
            $items[] = $item->type . ' ' . $item->slug.'_'.$item->language.' '.$item->version;
        }
        $lists['translations'] = implode(', ', $items);
    }

    $counts['total'] = $counts['plugins'] + $counts['themes'] + $counts['wordpress'] + $counts['translations'];
    $counts['index'] = array($counts['plugins'], $counts['themes'], $counts['wordpress'], $counts['translations']);
    $titles = array();

    if ( $counts['wordpress'] ) {
        /* translators: %d: Number of available WordPress updates. */
        $titles['wordpress'] = sprintf( __( '%d WordPress Update' ), $counts['wordpress'] ) .
                               '<br /><small>[' . $lists['wordpress'] . ']</small>';
    }
    if ( $counts['plugins'] ) {
        /* translators: %d: Number of available plugin updates. */
        $titles['plugins'] = sprintf( _n( '%d Plugin Update', '%d Plugin Updates', $counts['plugins'] ), $counts['plugins'] ) . 
                             '<br /><small>[' . $lists['plugins'] . ']</small>';
    }
    if ( $counts['themes'] ) {
        /* translators: %d: Number of available theme updates. */
        $titles['themes'] = sprintf( _n( '%d Theme Update', '%d Theme Updates', $counts['themes'] ), $counts['themes'] ) . 
                            '<br /><small>[' . $lists['themes'] . ']</small>';
    }
    if ( $counts['translations'] ) {
        $titles['translations'] = __( 'Translation Updates' ) . 
                                  '<br /><small>[' . $lists['translations'] . ']</small>';
    }
 
    $update_title = !empty($titles) ? '<div><ul><li>' . implode( '</li><li>', $titles ) . '</li></ul></div>' : '';

    $update_data = array(
        'counts' => $counts,
        'title'  => $update_title,
        'lists'  => $lists
    );

    if ($update_data['counts']['total'] == 0) {
        return array(
                'text'  => '', 
                'count' => 0,
                'index' => array(0,0,0,0)
            );
    }
    return array(
            'text'  => __('Updates need', 'silent-warning') . '&nbsp;: ' . $update_data['title'], 
            'count' => $update_data['counts']['total'],
            'index' => $update_data['counts']['index']
        );
}

function silent_warning_802_check_admin($options)
{
    $user_count_data = count_users();
    $now = $user_count_data['avail_roles']['administrator'];
    if ($now <= $options['admin_count']) {
        return array('text' => '', 'diff' => 0);
    }
    $result = array();
    $args = array(
            'role'    => 'administrator',
            'orderby' => 'ID',
            'order'   => 'asc'  
        );
    $admins = get_users($args);
    $text = array();
    for ($i = $options['admin_count']; $i <= count($admins)-1; $i++) {
    	$text[] = $admins[$i]->user_nicename . '&nbsp;(<a href="mailto:'.$admins[$i]->user_email.'">'.$admins[$i]->user_email.'</a>)'.
                  '&nbsp;-&nbsp;<small>'.$admins[$i]->user_registered.'</small>';
    }
    $result['diff'] = $now - $options['admin_count'];
    $result['text'] = __('New administrators', 'silent-warning').'<div><ul><li>'. implode('</li><li>', $text) . '</li></ul></div>';
    return $result;
}

function silent_warning_802_check_db($options)
{
    global $wpdb;
    
    $data = $wpdb->get_results('SHOW TABLE STATUS');
    $size = 0;
    foreach ($data as $table) {
        $size += $table->Data_length + $table->Index_length;  
    }
    
    if ($size < ($options['database_limit'] * 1024 * 1024)) {
        return '';
    }
    
    $si_prefix = array( 'B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB' );
    $base = 1024;
    $class = min((int)log($size , $base) , count($si_prefix) - 1);
    $used = sprintf('%1.0f' , $size / pow($base, $class)) . ' ' . $si_prefix[$class];

    return wp_sprintf( __('Database size error', 'silent-warning'), $options['database_limit']) . '&nbsp;<small>[' . __('is used','silent-warning') . '&nbsp;'.$used.']</small>';
}

function silent_warning_802_check_site_health($options)
{
	$get_issues = get_transient( 'health-check-site-status-result' );
	$issue_counts = array();
	if ( false !== $get_issues ) {
		$issue_counts = json_decode( $get_issues, true );
	}

	if ( ! is_array( $issue_counts ) || ! $issue_counts ) {
		$issue_counts = array(
			'good'        => 0,
			'recommended' => 0,
			'critical'    => 0,
		);
	}
    $issues_total = $issue_counts['recommended'] + $issue_counts['critical'];

    if ($issues_total != $options['health']) {
        $options['health'] = $issues_total;
        update_option('silent_warning_options', $options, true); 
        return __('Site health warning', 'silent-warning') .
               '&nbsp;<small>[' . wp_sprintf( __('%s message(s)','silent-warning'), $issues_total) . '&nbsp;]</small>';
    }

    return '';
}


function silent_warning_802_checklist()
{
    $options   = silent_warning_802_get_options('silent_warning_options');
    $legend    = get_option('silent_warning_legend');
    if (empty($legend)) {
        $legend = array(0,0,0,0,array(0,0,0,0),0,0,0);
    }
    $now_error = array(0,0,0,0,array(0,0,0,0),0,0,0);
    $html      = array();

    // Delete files
    silent_warning_802_deletefiles();
  
    $is_SendEmail = false;
    
    // Check index.php size
    $result = silent_warning_802_check_index($options);
    if ($result == '') { 
        $now_error[0] = 0; 
    } else {
        $html[] = $result;
        $now_error[0] = 1; 
    }
	if ($legend[0] < $now_error[0]) {
	   $is_SendEmail = true;   
	} 

    // Check wp-config.php size
    $result = silent_warning_802_check_config($options);
    if ($result == '') { 
        $now_error[1] = 0; 
    } else {
        $html[] = $result;
        $now_error[1] = 1; 
    }
	if ($legend[1] < $now_error[1]) {
	   $is_SendEmail = true;   
	} 

    // Check .htaccess size
    $result = silent_warning_802_check_access($options);
    if ($result == '') { 
        $now_error[2] = 0; 
    } else {
        $html[] = $result;
        $now_error[2] = 1; 
    }
	if ($legend[2] < $now_error[2]) {
	   $is_SendEmail = true;   
	} 

    // Check free space
    $result = silent_warning_802_check_free($options);
    if ($result == '') { 
        $now_error[3] = 0; 
    } else {
        $html[] = $result;
        $now_error[3] = 1; 
    }
	if ($legend[3] < $now_error[3]) {
	   $is_SendEmail = true;   
	} 

    // Check updates need
    $result = silent_warning_802_check_updates();
    if ($result['text'] == '') { 
        $now_error[4] = array(0,0,0,0); 
    } else {
        $html[] = $result['text'];
        $now_error[4] = $result['index']; 
    }
    for ($i = 0; $i <= count($now_error[4])-1; $i++) {
        if ($legend[4][$i] != $now_error[4][$i]) {
            $is_SendEmail = true;    	   
    	}
    }

    // Check admin user count
    $result = silent_warning_802_check_admin($options);
    if ($result['text'] == '') { 
        $now_error[5] = 0; 
    } else {
        $html[] = $result['text'];
        $now_error[5] = 1; 
    }
	if ($legend[5] < $now_error[5]) {
	   $is_SendEmail = true;   
	} 
    
    // Check DB size 
    $result = silent_warning_802_check_db($options);
    if ($result == '') { 
        $now_error[6] = 0; 
    } else {
        $html[] = $result;
        $now_error[6] = 1; 
    }
	if ($legend[6] < $now_error[6]) {
	   $is_SendEmail = true;   
	} 

    // Site health 
    $result = silent_warning_802_check_site_health($options);
    if ($result == '') { 
        $now_error[7] = 0; 
    } else {
        $html[] = $result;
        $now_error[7] = 1; 
    }
	if ($legend[7] < $now_error[7]) {
	   $is_SendEmail = true;   
	} 

    update_option('silent_warning_legend', $now_error, true); 

    if ($is_SendEmail) {
        update_option('silent_warning_show_alert', true, true);
        silent_warning_802_send_mail($html);
    }
}


function silent_warning_802_send_mail($html)
{
    if (empty($html)) { return ''; }
    $body = '
        <!DOCTYPE HTML>
        <html>
            <head>
            	<meta content="text/html; charset=UTF-8" http-equiv="Content-Type" />
            	<title>'.__('WordPress plugin alert', 'silent-warning').'</title>
                <style>
                    .small {font-size: 80%;}
                    .upper {text-transform: uppercase;}
                    hr {border:none;border-top: 1px solid #888888;}
                    h1, h2, h3, a {color: #4058C2;}
                    table {font-family:Tahoma;font-size:12px;color:#2D2D2D;}
                    td {padding:2px;}
                    li {margin-bottom: 4px;}
                </style>
            </head>
            <body style="background-color: #F3F3F3;color: #333333;padding:10px;">
                <div style="max-width:600px;border:1px solid #C3C3C3;background-color:#FFFFFF;font-family:Tahoma;font-size:13px;color:#2D2D2D;">
                    <div style="padding-left: 25px;padding-right: 25px;padding-bottom: 25px;">
                        <div style="text-align:center">' .
                        '<h3>'.__('Administrator intervention required!', 'silent-warning').'</h3>' .
                        '<hr></div>' .
                        '<p style="text-align:left">' .
                        wp_sprintf( __('Based on these settings, the following items require <a href="%s">%s</a> administrative action:', 'silent-warning'), esc_url( home_url('/')), get_bloginfo('name')). 
                        '</p><ul>';
    
    $body .= '<li>' . implode("</li>\r\n<li>", $html) . '</li></ul>';

    $body .= '<p>'. wp_sprintf( __('You can sign in to the admin interface by <a href="%s">clicking here</a>.', 'silent-warning'), wp_login_url()) . '</p>' .
            '</div>
        </body>
    </html>';

    $to = array();
    $options = silent_warning_802_get_options('silent_warning_options');
    if ($options['to_admins'] == 1) {
        $admin_email = get_option( 'admin_email' );
        if (is_array($admin_email)) {
            $to = $admin_email;
        } else {
            $to[] = $admin_email;
        }
    }
    if ($options['to_other'] != '') {
        $add = explode(',',$options['to_other']);
        foreach ($add as $item) {
            $item = trim($item);
            if ($item != '') {
                $to[] = $item;
            }
        }
    }

    $headers = array('Content-Type: text/html; charset=UTF-8');    
    $subject = __('WordPress plugin alert', 'silent-warning') . ' [' . esc_url( home_url('/') ) . ']';
    if (count($to) > 0) {
        $result = wp_mail($to, $subject, $body, $headers, null);
    }
}

function silent_warning_802_cron_function() {
    silent_warning_802_checklist();
}
add_action ('silent_warning_cron_job', 'silent_warning_802_cron_function'); 

function silent_warning_802_cron_starter_deactivate() {	
	$timestamp = wp_next_scheduled ('silent_warning_cron_job');
	wp_unschedule_event ($timestamp, 'silent_warning_cron_job');
} 
register_deactivation_hook (__FILE__, 'silent_warning_802_cron_starter_deactivate');


if ( is_admin() ){ 
    include( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'silent-warning-setup.php' );
    $my_settings_page = new silent_warning_802_settings();
    
    function silent_warning_802_get_extra_meta_links($meta, $file, $data, $status) {

        if (plugin_basename(__FILE__) == $file) {
            $lang = get_bloginfo('language');
            if ($lang == 'hu') {
                $url = 'http://wpdemo.dovi42.hu/csendes-figyelmeztetes';
            } else {
                $url = 'http://wpdemo.dovi42.hu/silent-warning';
            } 
            $meta[] = "<a href='".$url."' target='_blank' title='" . __('Detailed description', 'silent-warning') . "'>".__('Detailed description', 'silent-warning')."</a>";
     
            $meta[]  = '<a href="https://wordpress.org/support/plugin/silent-warning/reviews/">'.
                       __('Please rating!', 'silent-warning') . '&nbsp;' .
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '</a>';
        }
        return $meta;
    }
    add_filter("plugin_row_meta", 'silent_warning_802_get_extra_meta_links', 10, 4);
}

// Add settings link to plugins page 
function silent_warning_802_add_settings_link( $links ) {
    $settings_link = '<a href="options-general.php?page=silent-warning-setting-admin">' . __( 'Settings' ) . '</a>';
    array_unshift( $links, $settings_link );
  	return $links;
}
$plugin = plugin_basename( __FILE__ );
add_filter( "plugin_action_links_$plugin", 'silent_warning_802_add_settings_link' );

function silent_warning_802_notice() {
    if( get_transient( 'silent_warning_802_notice' ) ) {
        if (get_transient( 'silent_warning_802_notice' ) == 1) {
            $link = 'update-core.php';
        } else {
            if (get_transient( 'silent_warning_802_notice' ) == 2) {
                $link = 'site-health.php';
            } else {
                $link = 'options-general.php?page=silent-warning-setting-admin&silent-warning-tab=settings';
            }
        }
        echo '<div class="notice notice-error"><p>' . 
             '<strong>' . __('Silent warning', 'silent-warning') . ':</strong> ' .
             __('Administrator intervention required!', 'silent-warning') . ' ' .
             '<a href="'.$link.'">' . __('Please click here!', 'silent-warning') . '</a>' .
             '</p></div>';
        delete_transient( 'silent_warning_802_notice' );
    }
}
add_action( 'admin_notices', 'silent_warning_802_notice' );

function silent_warning_802_check_intervention_required()
{
$legend = get_option('silent_warning_legend');
    if (get_option('silent_warning_show_alert')) {
        $legend = get_option('silent_warning_legend');
        $update = 0;
        for ($i = 0; $i <= count($legend[4])-1; $i++) {
        	$update = $update + $legend[4][$i]; 
        }
        if ($update > 0) {
            set_transient( 'silent_warning_802_notice', 1 );
        } else {
            if ((isset($legend[7])) and ($legend[7] > 0)) {
                set_transient( 'silent_warning_802_notice', 2 );
            } else {
                $sum = $legend[0] + $legend[1] + $legend[2] + $legend[3] + $legend[5] + $legend[6];
                if ($sum > 0) {
                    set_transient( 'silent_warning_802_notice', 3 );
                }
            }
        }
        update_option('silent_warning_show_alert', false, true);
    }
}
add_action('admin_init', 'silent_warning_802_check_intervention_required');

